# ======================================================================================================================
#  fennec, a free and open source game engine
#  Copyright © 2025  Medusa Slockbower
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <https://www.gnu.org/licenses/>.
# ======================================================================================================================

# this script finds libxkbcommon and dependencies

macro(fennec_check_xkb)
    set(XKB_FOUND 0)

    find_path(
            XKB_INCLUDE_DIR
            NAMES xkbcommon/xkbcommon.h
    )
    find_library(
            XKB_LIBRARY
            NAMES xkbcommon libxkbcommon
    )

    if(XKB_INCLUDE_DIR AND XKB_LIBRARY)
        message(STATUS "Found XKB: ${XKB_LIBRARY}")

        get_filename_component(
                XKB_LIBRARY
                ${XKB_LIBRARY}
                NAME
        )

        set(XKB_FOUND 1)

        list(APPEND FENNEC_EXTRA_SOURCES
                # Dynamic Library Files
                include/fennec/platform/linux/xkb/lib/fwd.h
                include/fennec/platform/linux/xkb/lib/sym.h
                include/fennec/platform/linux/xkb/lib/xkbcommon.h
                include/fennec/platform/linux/xkb/lib/loader.h source/platform/linux/xkb/lib/loader.cpp

                # Fennec files
        )

        list(APPEND FENNEC_COMPILE_DEFINITIONS
                FENNEC_HAS_XKB=1
                FENNEC_LIB_XKB="${XKB_LIBRARY}"
        )
    endif()
endmacro()